package com.example.catchTheLetters;

import com.example.catchTheLetters.controller.LevelController;
import com.example.catchTheLetters.entity.Level;
import com.example.catchTheLetters.entity.ScoreInfo;
import com.example.catchTheLetters.entity.VersionDownload;
import com.example.catchTheLetters.utils.R;
import jakarta.annotation.Resource;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

@SpringBootTest
class TestInsertLevel {

    @Resource
    private LevelController levelController;

    @Resource
    private MongoTemplate mongoTemplate;

    private final List<String> words = new ArrayList<>() {
        {
            add("apple");
            add("banana");
            add("cherry");
            add("date");
            add("elderberry");
            add("fig");
            add("grape");
            add("honeydew");
            add("imbe");
            add("jackfruit");
            add("kiwi");
            add("lemon");
            add("mango");
            add("nectarine");
            add("orange");
            add("papaya");
            add("quince");
            add("raspberry");
            add("strawberry");
            add("tangerine");
            add("ugli");
            add("vanilla");
            add("watermelon");
            add("ximenia");
            add("yuzu");
            add("zucchini");
        }
    };

    @Disabled
    @Test
    void testInsertLevel() {
        // 存20个关卡
        for (int i = 0; i < 20; i++) {
            var type = new Random().nextInt(2);
            // 如果是1，则需要设置目标分数
            var targetScore = type == 1 ? new Random().nextInt(100) : null;
            // 如果是0，则单词列表5个就够，否则15个
            var wordList = new ArrayList<String>();
            for (int j = 0; j < (type == 0 ? 5 : 15); j++) {
                wordList.add(words.get(new Random().nextInt(words.size())));
            }
            // 时间全部设置为3分钟
            var level = new Level(Integer.toString(i), i, "Level " + i, type, 180000L, targetScore, wordList);

            levelController.create(level);
        }
    }

    @Disabled
    @Test
    void insertALevel() {
        var type = new Random().nextInt(2);
        // 如果是1，则需要设置目标分数
        var targetScore = type == 1 ? new Random().nextInt(100) : null;
        // 如果是0，则单词列表5个就够，否则15个
        var wordList = new ArrayList<String>();
        for (int j = 0; j < (type == 0 ? 5 : 15); j++) {
            wordList.add(words.get(new Random().nextInt(words.size())));
        }
        // 时间全部设置为3分钟
        var level = new Level("21", 21, "Level 21", type, 180000L, targetScore, wordList);

        levelController.create(level);
    }

    @Test
    @Disabled
    void pageTest(){
        Pageable pageable = PageRequest.of(0, 1);
        List<ScoreInfo> scores = mongoTemplate.find(new Query(Criteria.where("levelId").is("0")).with(pageable), ScoreInfo.class);
        System.out.println(scores);
    }

    @Test
    @Disabled
    void newTest(){
        Query query = new Query()
                .with(Sort.by(Sort.Direction.DESC,"time"))
                .limit(5);
        var list = mongoTemplate.find(query, VersionDownload.class);
        System.out.println(list);
    }
}
